#include "global.h"

	QHash<QString, QString> workValue;
	QHash<QString, QString> defValue;
	QVector<OkProfile> profiles;
	QPoint clickPos;
	bool compositeEnabled;

// Строка в двоичное
bool strToBool (QString b){
	bool bb;
	if (b.toUpper() == "TRUE") {bb=true;}
		else {bb=false;}
	return bb;
}

// Преобразование строки, содержащей параметры цвета "R,G,B,A" в QColor
QColor strToColor(QString strColor){
	QColor color (strColor.section (",",0,0).toInt(), strColor.section (",",1,1).toInt(), strColor.section (",",2,2).toInt(), strColor.section (",",3,3).toInt());
	return color;
}

// Преобразование QColor в строку "R,G,B,A"
QString strFromColor(QColor color){
	QString str=QString::number (color.red())+","+QString::number (color.green())+","+QString::number (color.blue())+","+QString::number (color.alpha());
	return str;
}

// Строка в целое
int strToInt(QString Str, long Alternative){
	bool ok;
	long a=Str.toInt (&ok);
	if (ok) return a;
	else return Alternative;
}

// Получение значения из массива
QString getValue (QString profile, QString parameter, QString valuedef){
	OkProfile pr=getProfile (profile);
	QString value=valuedef;
	int i=pr.parameters.indexOf (parameter);
	if (i>-1) value=pr.values[i];
	return value;
}

// Получение профиля из массива
OkProfile getProfile (QString pr){
	OkProfile profile;
	for (int i=0;i<profiles.size();i++)
		if (profiles[i].name == pr) profile=profiles[i];
	return profile;
}

int calcHPosition (QString value, int width, int offset){
	int left=0;
	QDesktopWidget desktop;
	if (value.toUpper() == "LEFT") left=offset;
		else if (value.toUpper() == "RIGHT") left=desktop.width()-width-offset;
			else if (value.toUpper() == "CENTER") left=(desktop.width()-width)/2;
				else left=value.toInt();
	return left;
}

int calcVPosition (QString value, int height, int offset){
	int top=0;
	QDesktopWidget desktop;
	if (value.toUpper() == "TOP") top=offset;
		else if (value.toUpper() == "BOTTOM") top=desktop.height()-height-offset;
			else if (value.toUpper() == "CENTER") top=(desktop.height()-height)/2;
				else top=value.toInt();
	return top;
}

void setConfigValue (QString profile, QString parameter){
	workValue[parameter]=getValue (profile,parameter,defValue[parameter]);
}

QStringList strToArgs (QString str){
	QString st=str+" ";
	QStringList sl;
	QString word="";
	bool endQuote=false;
	for (int i=0;i<st.length();i++){
		if (st[i] == '\"' && st[i-1] !='\\') endQuote=!endQuote;
		if (st[i] == ' ' && !endQuote) {
			if (word != "") sl.append (word);
			word="";
			}
		else {
			if (st[i] != '\"') word=word+st[i];
			if (st[i] == '\"' && st[i-1] =='\\') word=word+st[i];
			}
	}
	return sl;
}