#ifndef ROUNDINDICATOR_H
#define ROUNDINDICATOR_H

#include <QLabel>
#include <QMouseEvent>
#include <QDesktopWidget>
#include <QPainter>
#include "math.h"
#include <QBitmap>
#include <QImage>
#include <QDebug>
#include <QtDBus>
#include <QGraphicsBlurEffect>
#include "global.h"
//#include "qtdisplay.h"

class roundIndicator : public QLabel{
Q_OBJECT
Q_CLASSINFO("D-Bus Interface", "org.kochkin.okindd")
public:
	roundIndicator (QLabel * parent = 0);
	virtual ~roundIndicator();

	void setDigitsFont(QString name, bool bold, bool italic);
	int getCenterDiameter(QString centerDiameter);
	void showCurrent (int value);

	QPixmap picture, shadow;
	int centerDiameter, diameter, fullDiameter, offset;
	int posVert, posHor;
	int angle, animationFPS, animationPass;
	int valueMin, valueMax, currentValue, prevValue;
	QColor colorULB,colorBRB,colorULI,colorBRI,colorULC,colorBRC, colorDigits, colorDigitsShadow;
	bool digitsEnabled;
	QFont digitsFont;
	float opacity;
	QTimer *time, *animationTimer;
	float anglePos, prevAngle, valueOut, animationX;
	int 	angleLength, valueRange, angleBegin;
private:
	virtual void mousePressEvent (QMouseEvent *e);
	virtual void mouseMoveEvent (QMouseEvent *e);
	virtual void mouseReleaseEvent (QMouseEvent *);
	virtual void paintEvent (QPaintEvent *);
private slots:
	void nextStepAnimation();

public slots:
	void setPosition (QString hPosition, QString vPosition);
	void setDiameter (int Diameter);
	void setAngle (int Angle);
	void setValueMinimum (int valueMinimum);
	void setValueMaximum (int valueMaximum);
	void setCurrentValue (int value);
	void setPicture (QString pictureFile);
	void setCenterDiameter (QString CenterDiameter);
	void setColorULB (QString color);
	void setColorBRB (QString color);
	void setColorULI (QString color);
	void setColorBRI (QString color);
	void setColorULC (QString color);
	void setColorBRC (QString color);
	void setDigitsEnabled (QString enabled);
	void setDigitsFont (QString name, QString bold, QString italic);
	void setColorDigits (QString color);
	void setColorDigitsShadow (QString color);
	void setOpacity (QString Opacity);
	void setEnabled (QString enabled);
	void Indicator (QString File, QString Left, QString Top, QString Diameter, QString Angle, int value, int Time);
	void showIndicator();
	void hideIndicator();
	int getValueMinimum();
	int getValueMaximum();
	int getCurrentValue();
	int getCurrentPositionLeft();
	int getCurrentPositionTop();
	QString getCurrentPictureFile();
	QString getCurrentCenterDiameter();
	int getCurrentDiameter();
	int getCurrentAngle();
	QString getCurrentOpacity();
	QString getCurrentColorULB ();
	QString getCurrentColorBRB ();
	QString getCurrentColorULI ();
	QString getCurrentColorBRI ();
	QString getCurrentColorULC ();
	QString getCurrentColorBRC ();
	QString getCurrentColorDigits ();
	QString getCurrentColorDigitsShadow ();
	QString getCurrentDigitsFontName();
	QString getCurrentDigitsFontBold();
	QString getCurrentDigitsFontItalic();
	QString getDigitsEnabled();
	QString getEnabled();
	QVariant getValueFromDBUS(QVariant altValue);
	void workValuesToCurrent ();
};
#endif
